// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// BinFilterDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "BinFilter.h"
#include "BinFilterDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBinFilterDlg _CAO

CBinFilterDlg::CBinFilterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBinFilterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBinFilterDlg)
	m_direction = 0;
	m_bfilterdirection = 0;
	m_binlevel = 128;
	m_vpix = 5;
	m_hpix = 5;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_blnVideoOpened = false;
}

void CBinFilterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBinFilterDlg)
	DDX_CBIndex(pDX, IDC_DIRECTION, m_direction);
	DDX_CBIndex(pDX, IDC_BFILTERDIRECTION, m_bfilterdirection);
	DDX_Text(pDX, IDC_BINLEVEL, m_binlevel);
	DDV_MinMaxInt(pDX, m_binlevel, 0, 255);
	DDX_Text(pDX, IDC_VPIX, m_vpix);
	DDV_MinMaxInt(pDX, m_vpix, 1, 50);
	DDX_Text(pDX, IDC_HPIX, m_hpix);
	DDV_MinMaxInt(pDX, m_hpix, 1, 50);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBinFilterDlg, CDialog)
	//{{AFX_MSG_MAP(CBinFilterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_EN_CHANGE(IDC_BINLEVEL, OnChangeBinlevel)
	ON_BN_CLICKED(IDC_CONTRCT, OnContrct)
	ON_BN_CLICKED(IDC_EXPAND4, OnExpand4)
	ON_BN_CLICKED(IDC_EXPAND, OnExpand)
	ON_BN_CLICKED(IDC_CONTRCT4, OnContrct4)
	ON_BN_CLICKED(IDC_NOT, OnNot)
	ON_BN_CLICKED(IDC_SOLODEL, OnSolodel)
	ON_BN_CLICKED(IDC_EXPANDDIR, OnExpanddir)
	ON_BN_CLICKED(IDC_CONTRCTDIR, OnContrctdir)
	ON_BN_CLICKED(IDC_BFILTER, OnBfilter)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBinFilterDlg bZ[W nh

BOOL CBinFilterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no  = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx );

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImageOrg.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImageOrgBin.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImageDstBin.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImageTemp.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxBinFilter.CreateInstance( __uuidof( FvxBinFilter ) ); 
		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_ExeRegion->Putxs( -1 );
		m_ExeRegion->Putxe( -1 );
		m_ExeRegion->Putys( -1 );
		m_ExeRegion->Putye( -1 );

		Binarize();

		m_FvxDisplayEx->ClearOverlay( -1 );
		m_FvxDisplayEx->PutPenColor( 0xFF0000 );
		m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_DIRECTION );
		pcmb->AddString( "" );
		pcmb->AddString( "" );
		pcmb->AddString( "" );
		pcmb->AddString( "" );
		pcmb->AddString( "" );
		pcmb->AddString( "E" );
		m_direction = 0;

		pcmb = ( CComboBox* )GetDlgItem( IDC_BFILTERDIRECTION );
		pcmb->AddString( "YX_DIRECTION" );
		pcmb->AddString( "XY_DIRECTION" );
		pcmb->AddString( "Y_ONLY_DIRECTION" );
		pcmb->AddString( "X_ONLY_DIRECTION" );
		m_bfilterdirection = 0;

		UpdateData(FALSE); 

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImageOrg );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImageOrg );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImageOrg );
		Binarize();

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	
	UpdateData(FALSE); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CBinFilterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CBinFilterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CBinFilterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Ql
void CBinFilterDlg::Binarize()
{
	long BinLevel;

	UpdateData( TRUE );

	BinLevel = m_binlevel;
 
    if ( BinLevel < 0 ) BinLevel = 0;
    if ( BinLevel > 255 ) BinLevel = 255;
    
    m_FvxChangeImage->FixedLevel( m_FvxImageOrg , m_FvxImageOrgBin , BinLevel );
    m_FvxDisplayEx->DrawImage( m_FvxImageOrgBin );

}

BOOL CBinFilterDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CBinFilterDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
	
}

void CBinFilterDlg::OnExeregion() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	long lngOK;
	double dblTemp;
	
	UpdateData(TRUE);

    m_FvxROI->SetRectangle( m_ExeRegion );

    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( false );
	m_FvxROI->MakeROIDialog( m_FvxImageOrgBin, &lngOK);

    if ((lngOK == 1) && (m_FvxROI->GetCheckRectangle() == 1)) {
        m_FvxROI->GetRectangle( m_ExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_ExeRegion->Getxe() < m_ExeRegion->Getxs() ) {
            dblTemp = m_ExeRegion->Getxs();
			m_ExeRegion->Putxs( m_ExeRegion->Getxe() );
            m_ExeRegion->Putxe( dblTemp );
		}
		if ( m_ExeRegion->Getye() < m_ExeRegion->Getys() ) {
            dblTemp = m_ExeRegion->Getys();
            m_ExeRegion->Putys( m_ExeRegion->Getye() );
            m_ExeRegion->Putye( dblTemp );
		}
	}

	// ͈͂̓Kp
	m_FvxBinFilter->SetInspectArea( m_ExeRegion );
	m_FvxDisplayEx->ClearOverlay( -1 );
    m_FvxDisplayEx->PutPenColor( 0xFF0000 );
    m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

}

void CBinFilterDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
	m_FvxVideo->ChangeImageSize( m_FvxImageOrg );

	m_FvxVideo->GrabSync( m_FvxImageOrg );	// 捞

    // Ql\
	Binarize();
	
}

// 摜t@CǍ
void CBinFilterDlg::OnLoadimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImageTemp );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜`FbN
		if ( m_FvxImageTemp->GetImageType() != imageGray ){

			MessageBox("O[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImageTemp->PutBitPerPixel( 8 );
            m_FvxImageTemp->PutImageType( imageGray );
            m_FvxImageTemp->PutImageWidth( 512 );
            m_FvxImageTemp->PutImageHeight( 480 );

		}

        // Ql摜ZW摜H
        if ( m_FvxImageTemp->GetBitPerPixel() == 1 ) {
            m_FvxImageOrg->ClearImage();
            m_FvxImageTemp->CopyTo( m_FvxImageOrgBin );
            m_FvxDisplayEx->DrawImage( m_FvxImageOrgBin );
		} else if ( m_FvxImageTemp->GetBitPerPixel() == 8 ) {
            m_FvxImageTemp->CopyTo( m_FvxImageOrg );
			Binarize();
		} else {
			MessageBox("1bit/8bitȊObmpł" , "ǍG[" , MB_ICONWARNING | MB_OK );
		}

	}
	
}

void CBinFilterDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t(cFileDlg.GetPathName()) );

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImageOrgBin ); 			
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}	
}

void CBinFilterDlg::OnChangeBinlevel() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	Binarize();
}

// k
void CBinFilterDlg::OnContrct() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // 摜̈ꕔ̏ꍇɁAȊǑ摜ۑ悤ARs[܂
    m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    
    // tB^s
    m_FvxBinFilter->Contrct( m_FvxImageOrgBin, m_FvxImageDstBin );
    
    // ωɑĕʂ̏ł悤ɁÃC[WɃRs[Ă܂B
    // ÃRs[sƉ摜̗L͈͂ZbgĂ܂܂B
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin );
	
}

// SߖTk
void CBinFilterDlg::OnExpand4() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    m_FvxBinFilter->Expand4( m_FvxImageOrgBin, m_FvxImageDstBin );
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin );
	
}

// c
void CBinFilterDlg::OnExpand() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    m_FvxBinFilter->Expand( m_FvxImageOrgBin, m_FvxImageDstBin );
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin );
	
}

// SߖTk
void CBinFilterDlg::OnContrct4() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    m_FvxBinFilter->Contrct4( m_FvxImageOrgBin, m_FvxImageDstBin );
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin );
	
}

// ]
void CBinFilterDlg::OnNot() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    m_FvxBinFilter->Not( m_FvxImageOrgBin, m_FvxImageDstBin );
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin );
	
}

// Ǘ_
void CBinFilterDlg::OnSolodel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    m_FvxBinFilter->Solodel( m_FvxImageOrgBin, m_FvxImageDstBin );
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin );
	
}

// wtߖTc
void CBinFilterDlg::OnExpanddir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    UpdateData( TRUE );
	m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    m_FvxBinFilter->ExpandDir( m_FvxImageOrgBin, m_FvxImageDstBin, ( enum DIRECTION_BIN_TYPE )m_direction );
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin );
}

// wtߖTk
void CBinFilterDlg::OnContrctdir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    UpdateData( TRUE );
    m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    m_FvxBinFilter->ContrctDir( m_FvxImageOrgBin, m_FvxImageDstBin, ( enum DIRECTION_BIN_TYPE )m_direction );
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin ); 
	
}

// mCY
void CBinFilterDlg::OnBfilter() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if (! UpdateData( TRUE )) return;
    m_FvxImageOrgBin->CopyTo( m_FvxImageDstBin );
    m_FvxBinFilter->Bfilter( m_FvxImageOrgBin, m_FvxImageDstBin, m_vpix, m_hpix, ( enum BFILTER_TYPE )m_bfilterdirection );
    m_FvxImageDstBin->CopyTo( m_FvxImageOrgBin );
    m_FvxDisplayEx->DrawImage( m_FvxImageDstBin );

}

void CBinFilterDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}
